#define FOCUS_PIN 51
#define FOCUS_LED 50
#define SHUTTER_PIN 53
#define SHUTTER_LED 52
#define SENSOR_PIN 49
//#define TEST_PIN 45

int counter = 0;
int tooth = 10;

//ISR
void pulse()
{
  //digitalWrite(SHUTTER_PIN, HIGH);
  //delay(2000); // May want to adjust this depending on shot type
  //digitalWrite(SHUTTER_PIN, LOW);
  digitalWrite(FOCUS_LED, HIGH);
  //delay(1000);  // doesn't work in an ISR! 
  digitalWrite(FOCUS_LED, LOW);
  counter++;
  Serial.println(counter);
  
  if(counter == tooth)
  {
      detachInterrupt(3);
      digitalWrite(SHUTTER_PIN, HIGH);
      delay(2000); // May want to adjust this depending on shot type
      digitalWrite(SHUTTER_PIN, LOW);
      digitalWrite(SHUTTER_LED, HIGH);
      delay(1000);
      digitalWrite(SHUTTER_LED, LOW);
      attachInterrupt(3, pulse, CHANGE);
  }
    
}

void setup()
{ 
  pinMode(FOCUS_PIN, OUTPUT);
  pinMode(SHUTTER_PIN, OUTPUT);
  digitalWrite(FOCUS_PIN, LOW);
  digitalWrite(SHUTTER_PIN, LOW);
  pinMode(FOCUS_LED, OUTPUT);
  pinMode(SHUTTER_LED, OUTPUT);
  pinMode(SENSOR_PIN, OUTPUT);
  attachInterrupt(3, pulse, CHANGE);
  //pinMode(TEST_PIN, OUTPUT);
  Serial.begin(9600);  
}



void loop()
{
  int cmd;
  bool trigger;

  while (Serial.available() > 0)
  {
    cmd = Serial.read();

    //digitalWrite(20, LOW);

    switch (cmd)
    {
    case '10':
    {
      tooth = 10;
    }
    case 'f':
      {
        digitalWrite(FOCUS_PIN, HIGH);
        delay(800); // May want to adjust this depending on focus time
        digitalWrite(FOCUS_PIN, LOW);
        digitalWrite(FOCUS_LED, HIGH);
        delay(1000);
        digitalWrite(FOCUS_LED, LOW); 
        break;
      }
    case 's':
      {
        digitalWrite(SHUTTER_PIN, HIGH);
        delay(2000); // May want to adjust this depending on shot type
        digitalWrite(SHUTTER_PIN, LOW);
        digitalWrite(SHUTTER_LED, HIGH);
        delay(1000);
        digitalWrite(SHUTTER_LED, LOW);

        // read the input on analog pin 0:
        int sensorValue = analogRead(A15);
        
        // Convert the analog reading (which goes from 0 - 1023) to a voltage (0 - 5V):
        float voltage = sensorValue * (5.0 / 1023.0);

        //Allow us to read the voltage
        Serial.println(voltage);
        
        break;
      }
      case 'v':
      {
        //digitalWrite(SENSOR_PIN, HIGH);
        //trigger = true;
        //Serial.println("lol");
        /*
        digitalWrite(SENSOR_PIN, HIGH);
        
        // read the input on analog pin 0:
        int sensorValue = analogRead(A15);
        
        // Convert the analog reading (which goes from 0 - 1023) to a voltage (0 - 5V):
        float voltage = sensorValue * (5.0 / 1023.0);

        //Allow us to read the voltage
        Serial.println(voltage);

        //Delay for seeing the LED blink
        //delay(1000);
        
        //digitalWrite(SENSOR_PIN, LOW);
        break;
        */
      }
    default:
      {
        //Serial.println("ERROR!");
      }
    }
  }
}
